= Development =
[[TOC(heading=About SecureCI™,depth=2,AboutSecureCI/*)]]

== Subversion ==

Having a central repository for the project source code is critical to being able to successfully integrate frequently. 
Not only do developers need to be able to conveniently check out and commit any code they are working on, but automated 
tools such as the continuous integration server also need to be able to check out code for automated building.

[http://subversion.tigris.org/ Subversion] is the source code repository system installed in SecureCI™.

 * [//svn/ Repository]
 * [/browser/ Browse via the web]
 * [/admin/accounts/users Manage User Accounts]
 * [/admin/subversion/svnauthz Manage Subversion Access Rights]
 * [/admin/general/svnpolicies SVN Policies]
 * [HowTo/UseExistingSubversion How do I use an existing/remote Subversion repository?]

<% if ::File.directory?("#{node['gitblit']['home']}") %>
== Git ==

Git is a free and open source distributed version control system designed to handle everything from small to very large 
projects with speed and efficiency.

Git is easy to learn and has a tiny footprint with lightning fast performance. 
It outclasses SCM tools like Subversion, CVS, Perforce, and !ClearCase with features like cheap local branching, 
convenient staging areas, and multiple workflows.

[http://git-scm.com/ Git] is a source code repository system installed in SecureCI™.

 * [/gitblit/repositories/ Repository]
 * [/admin/accounts/users Manage User Accounts]
 * [HowTo/UseGit How do I use an existing/remote Git repository?]

<% end %>
<% if ::File.directory?("#{node['jenkins']['home_dir']}") %>
== Jenkins ==

Continuous integration is the practice of frequently integrating a developer's code. The meaning of ''frequently'' 
varies from team to team. It could mean many times each day, once each day, or as each task is completed.

A continuous integration engine can be used to automate the process of continuous integration by monitoring the 
source code repository, watching for changes. When it notices a change, it kicks off an 
automated build which compiles and [../Testing tests] the application. [../Testing#Cobertura Code coverage] 
is tracked while the tests are running. The continuous integration engine is also used to regularly (perhaps nightly) 
perform [../CodeAnalysis code analyses] in order to provide feedback on code quality. Functional testing, 
deployment, and [../SecurityScanning security auditing] can all be automated through the continuous integration engine.

[http://jenkins-ci.org Jenkins] (formerly known as Hudson) is the continuous integration engine installed in SecureCI™.

 * [//jenkins/ Jenkins Dashboard]
 * [HowTo/UseJenkins How do I build my project with Jenkins?]

<% end %>
<% if ::File.directory?("#{node['secureci-ant']['home']}") %>
== Ant ==

It is important that the build process is repeatable and can be run on a non-developer machine (to avoid the "it works 
on my machine" issues). That helps a new developer get started and makes sure that the application is always ready to 
be released, even if only for a demonstration.

[http://ant.apache.org Apache Ant] is a build tool. It's primary focus is building Java projects. It is very widely 
used, mature, and integrates well into almost any modern Java IDE. 

{{{ 
#!comment
A sample [source:branches/sample-ant/build.xml build.xml] file is available in the sample application.
}}}

 * [HowTo/StartWithAnt How do I start a project with Ant?]

<% end %>
<% if ::File.directory?("#{node['maven']['m2_home']}") %>
== Maven ==

[http://maven.apache.org Apache Maven] is a software project management system. Although one of the things it does is 
to build Java projects, it also handles dependencies, can build a project web site, and generally makes a lot of tasks 
that Ant can handle easier by using predefined conventions in the project structure. A sample 
[source:branches/sample-maven/pom.xml pom.xml] file is available in the sample application.

If you have experience with neither Ant nor Maven, Maven may be able to get you started sooner. If you have an existing 
folder structure for your project, Ant may be easier to use.

 * [HowTo/StartWithMaven How do I start a project with Maven?]

<% end %>
<% if ::File.directory?("#{node['nexus']['home']}") %>
== Nexus ==

Maven handles downloading required third-party libraries for your project (i.e., dependencies). Rather than every 
developer on your team having to download the same libraries from the same remote repository, 
[http://nexus.sonatype.org/ Sonatype Nexus] provides a local repository for remote and locally-developed artifacts.

 * [//nexus/ Nexus administration]
 * [HowTo/UseNexus How do I use Nexus with my Maven project?]

<%end %>
=== Installation Details ===

Subversion is installed as a .deb package, with the repository parent path on the local file system in 
`<%= node['subversion']['repo_dir'] %>`.

Remote access is provided by the [../Support#ApacheHTTPServer Apache HTTP Server], using HTTP Basic Authentication 
(htpasswd file `<%= node['subversion']['auth_user_file'] %>`) and file-level access controlled by the dav_svn module (file 
`<%= node['subversion']['auth_access_file'] %>`). [../ProjectManagement#Trac Trac] shares the authentication and authorization files, 
and can be used to administer authentication and authorization using the 
[http://trac-hacks.org/wiki/AccountManagerPlugin AccountManagerPlugin] and the 
[http://trac-hacks.org/wiki/SvnAuthzAdminPlugin SvnAuthzAdminPlugin].

Trac also provides an interface for configuring pre and post hooks in Subversion using the 
[http://trac-hacks.org/wiki/TracSvnPoliciesPlugin TracSvnPoliciesPlugin].

<% if ::File.directory?("#{node['jenkins']['home_dir']}") %>
Jenkins runs standalone, proxied by [../Support#ApacheHTTPServer Apache HTTP Server] and 
installed in `<%= node['jenkins']['home_dir'] %>`. Plugins are installed for
<% node['secureci-jenkins']['plugins'].each do |plugin| %><%= plugin %>, <% end %>.

<% end %>
<% if ::File.directory?("#{node['nexus']['home']}") %>
Nexus is running under it's own Jetty container, proxied by [../Support#ApacheHTTPServer Apache HTTP Server] and
installed at `<%= node['nexus']['home'] %>` and uses a symlink to locate the `sonatype-work` 
directory as `<%= node['nexus']['work_link'] %>`.

<% end %>
<% if ::File.directory?("#{node['gitblit']['home']}") %>
GitBlit is running under it's own Jetty container, proxied by [../Support#ApacheHTTPServer Apache HTTP Server] and
installed at `<%= node['gitblit']['home'] %>`.

<% end %>
<% if ::File.directory?("#{node['secureci-ant']['home']}") && ::File.directory?("#{node['maven']['m2_home']}") %>
Ant and Maven are installed in `<%= node['tools']['base_dir'] %>`. The environment variables `$ANT_HOME`, `$M2_HOME`, and `$M2` are set for 
each user on login via the `/etc/profile.d/java.sh` script and the tools are automatically added to the path.

<% end %>

<%= node['trac']['wiki']['footer'] %>
